/*
 * cache.h
 *
 * Copyright (C) 1994, 1995, John Kilburg (john@cs.unlv.edu)
 *
 * See copyright.h for details.
 */
#include "copyright.h"

#ifndef __CACHE_H__
#define __CACHE_H__

#include <sys/types.h>
#include <time.h>

typedef struct _cache_entry
{
  char *path;                         /* path of cache file */
  time_t atime;                       /* access time */
  off_t size;                         /* size of data sort of */
  time_t expires;                     /* expires time */
  time_t mtime;                       /* modified time */
  struct _cache_entry *prev, *next;
} CacheEntry;

int IsCached _ArgProto((URLParts *));
void CacheInit _ArgProto((char *, int, int, char *));
Document *CacheRead _ArgProto((URLParts *));
void CacheWrite _ArgProto((Document *, URLParts *));
void CacheClean _ArgProto((int));

#endif
