/*
 * server.c
 *
 * Test server
 */
#include <stdio.h>
#include <time.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/param.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

void
main(argc, argv)
int argc;
char *argv[];
{
  int s;
  struct sockaddr_in addr;
  fd_set readfds;
  int port;
  int as;

  if (argc < 2) port = 22222;
  else port = atoi(argv[1]);

  s = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
  if (s < 0)
  {
    perror("socket");
    exit(1);
  }

  addr.sin_family = AF_INET;
  addr.sin_addr.s_addr = INADDR_ANY;
  addr.sin_port = htons((unsigned short)port);
  
  if (bind(s, (struct sockaddr *)&addr, sizeof(addr)))
  {
    perror("bind");
    exit(1);
  }

  if (listen(s, 1) < 0)
  {
    perror("listen");
    exit(1);
  }

  for (;;)
  {
    FD_ZERO(&readfds);
    FD_SET(s, &readfds);

    if (select(s + 1, &readfds, NULL, NULL, NULL) > 0)
    {    
      if (FD_ISSET(s, &readfds))
      {
        if ((as = accept(s, NULL, 0)) < 0) perror("accept");
        else sleep(1000);
      }
    }
    else perror("select");
  }

  close(s);

  exit(0);
}
