/*
 * dither.h
 *
 * Copyright (C) 1995, John Kilburg (john@isri.unlv.edu)
 */

#ifndef __DITHER_H__
#define __DITHER_H__ 1

typedef struct _dither_state
{
  Image          *image;	/* destination image */
  Image          *cimage;       /* source image */
  unsigned int    dll;		/* destination line length in bytes */
  unsigned char  *dst;		/* destination data */
  int            *curr;		/* current line buffer */
  int            *next;		/* next line buffer */
  int            *swap;		/* for swapping line buffers */
} ditherState;

ditherState *ditherInit _ArgProto((Image *));
int ditherAddLine _ArgProto((ditherState *, int));
void ditherDestroy _ArgProto((ditherState *)); 

#endif /* __DITHER_H__ */
